      SUBROUTINE PBCDZRO1( M, N, NZ, A, LDA, MINT, NINT, NEN )
*
*  -- PB-BLAS routine (version 2.1) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory.
*     April 28, 1996
*
*     .. Scalar Arguments ..
      INTEGER            LDA, M, MINT, N, NINT, NEN, NZ
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  PBCDZRO1 selects diagonal elements and makes them ZERO.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, JP, MN
*     ..
*     .. External Functions ..
      INTEGER            ICEIL
      EXTERNAL           ICEIL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
      JP = 0
      MN = M
*
      DO 10 J = 1, N-NZ
         A( MN+J, JP+J ) = ZERO
   10 CONTINUE
      MN = MN + MINT - NZ
      JP = JP + NINT - NZ
*
      DO 30 I = 2, ICEIL( NEN+NZ, NINT )
         DO 20 J = 1, MIN( N, NEN-JP )
            A( MN+J, JP+J ) = ZERO
   20    CONTINUE
         MN = MN + MINT
         JP = JP + NINT
   30 CONTINUE
*
      RETURN
*
*     End of PBCDZRO1
*
      END
